
Ruby - Bug #21141

`Time#utc?` does not work with a timezone object

02/15/2025 04:57 AM - nobu (Nobuyoshi Nakada)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v:  Backport: 3.1: REQUIRED, 3.2: REQUIRED, 3.3:

DONE, 3.4: DONE

Description

require 'timezone'

require 'tzinfo'

t = Time.now(in: "UTC")

t_timezone = Time.now(in: Timezone["UTC"])

t_tzinfo = Time.now(in: TZInfo::Timezone.get("UTC"))

p t.utc?          #=> true

p t_timezone.utc? #=> false

p t_tzinfo.utc?   #=> false

 This also affects strftime("%-z").

Associated revisions

Revision 06919949a60b42a8f30e8bd0cb075e17b05eebcd - 03/16/2025 03:09 AM - nobu (Nobuyoshi Nakada)

[Bug #21141] [DOC] Clarify what time is in UTC

Revision 06919949a60b42a8f30e8bd0cb075e17b05eebcd - 03/16/2025 03:09 AM - nobu (Nobuyoshi Nakada)

[Bug #21141] [DOC] Clarify what time is in UTC

Revision 06919949 - 03/16/2025 03:09 AM - nobu (Nobuyoshi Nakada)

[Bug #21141] [DOC] Clarify what time is in UTC

Revision 51bc992822f9108ad64de32d300e1cefd0e2da59 - 03/24/2025 06:43 AM - nobu (Nobuyoshi Nakada)

[Bug #21141] [DOC] Refine description of Time#utc?

Revision 51bc992822f9108ad64de32d300e1cefd0e2da59 - 03/24/2025 06:43 AM - nobu (Nobuyoshi Nakada)

[Bug #21141] [DOC] Refine description of Time#utc?

Revision 51bc9928 - 03/24/2025 06:43 AM - nobu (Nobuyoshi Nakada)

[Bug #21141] [DOC] Refine description of Time#utc?

Revision 42daa6c2a2b49b4e45f40736e25c7d182860f24a - 03/24/2025 06:49 AM - nobu (Nobuyoshi Nakada)

[Bug #21141] [DOC] Fix indentation

Revision 42daa6c2a2b49b4e45f40736e25c7d182860f24a - 03/24/2025 06:49 AM - nobu (Nobuyoshi Nakada)

[Bug #21141] [DOC] Fix indentation

Revision 42daa6c2 - 03/24/2025 06:49 AM - nobu (Nobuyoshi Nakada)

[Bug #21141] [DOC] Fix indentation

Revision bd99a2ef6ac72a43aacf8543aef19e8c1bcb354f - 03/27/2025 11:41 PM - nobu (Nobuyoshi Nakada)

[Backport #21141] [DOC] Clarify what time is in UTC

Revision 5ab0b9143ab5a92b134c6788f893ac539825b300 - 03/27/2025 11:41 PM - nobu (Nobuyoshi Nakada)
[Backport #21141] [DOC] Refine description of Time#utc?

Revision bd99a2ef6ac72a43aacf8543aef19e8c1bcb354f - 03/27/2025 11:41 PM - nobu (Nobuyoshi Nakada)

[Backport #21141] [DOC] Clarify what time is in UTC

Revision 5ab0b9143ab5a92b134c6788f893ac539825b300 - 03/27/2025 11:41 PM - nobu (Nobuyoshi Nakada)

[Backport #21141] [DOC] Refine description of Time#utc?

Revision bd99a2ef - 03/27/2025 11:41 PM - nobu (Nobuyoshi Nakada)

[Backport #21141] [DOC] Clarify what time is in UTC

Revision 5ab0b914 - 03/27/2025 11:41 PM - nobu (Nobuyoshi Nakada)

[Backport #21141] [DOC] Refine description of Time#utc?

Revision 4ca521e91342165ed35cb12c9868f10e2a6aa07c - 04/09/2025 08:27 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 06919949a60b42a8f30e8bd0cb075e17b05eebcd, 51bc992822f9108ad64de32d300e1cefd0e2da59,

42daa6c2a2b49b4e45f40736e25c7d182860f24a: [Backport #21141]

    [Bug #21141] [DOC] Clarify what time is in UTC

    [Bug #21141] [DOC] Refine description of `Time#utc?`

    [Bug #21141] [DOC] Fix indentation

Revision 4ca521e91342165ed35cb12c9868f10e2a6aa07c - 04/09/2025 08:27 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 06919949a60b42a8f30e8bd0cb075e17b05eebcd, 51bc992822f9108ad64de32d300e1cefd0e2da59,

42daa6c2a2b49b4e45f40736e25c7d182860f24a: [Backport #21141]

    [Bug #21141] [DOC] Clarify what time is in UTC

    [Bug #21141] [DOC] Refine description of `Time#utc?`

    [Bug #21141] [DOC] Fix indentation

Revision 4ca521e9 - 04/09/2025 08:27 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 06919949a60b42a8f30e8bd0cb075e17b05eebcd, 51bc992822f9108ad64de32d300e1cefd0e2da59,

42daa6c2a2b49b4e45f40736e25c7d182860f24a: [Backport #21141]

    [Bug #21141] [DOC] Clarify what time is in UTC

    [Bug #21141] [DOC] Refine description of `Time#utc?`

    [Bug #21141] [DOC] Fix indentation

History

#1 - 02/15/2025 07:46 AM - nobu (Nobuyoshi Nakada)

Maybe also this is related:

ENV["TZ"] = "UTC"

p Time.now.utc? #=> false

 Is it expected?

In other words, is that Time#utc? is true a special case, only when the time is created with the methods such as Time.utc, Time#utc, etc, that clearly

return a UTC time object?

#2 - 03/16/2025 03:25 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset git|06919949a60b42a8f30e8bd0cb075e17b05eebcd.

[Bug #21141] [DOC] Clarify what time is in UTC

#3 - 03/19/2025 07:20 PM - maximecb (Maxime Chevalier-Boisvert)
https://bugs.ruby-lang.org/projects/ruby-master/repository/git/revisions/06919949a60b42a8f30e8bd0cb075e17b05eebcd
https://bugs.ruby-lang.org/issues/21141


Should we backport this minor doc change?

#4 - 03/28/2025 02:58 PM - alanwu (Alan Wu)

- Backport changed from 3.1: REQUIRED, 3.2: REQUIRED, 3.3: REQUIRED, 3.4: REQUIRED to 3.1: REQUIRED, 3.2: REQUIRED, 3.3: REQUIRED,

3.4: DONE

#5 - 04/09/2025 08:28 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 3.1: REQUIRED, 3.2: REQUIRED, 3.3: REQUIRED, 3.4: DONE to 3.1: REQUIRED, 3.2: REQUIRED, 3.3: DONE, 3.4: DONE

ruby_3_3 4ca521e91342165ed35cb12c9868f10e2a6aa07c merged revision(s) 06919949a60b42a8f30e8bd0cb075e17b05eebcd, 

51bc992822f9108ad64de32d300e1cefd0e2da59, 42daa6c2a2b49b4e45f40736e25c7d182860f24a.
